/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Thema Threads
 */
 
// Achtung: Beim Compilieren ist das Flag -pthread notwendig, siehe makefile.

#include <iostream>
#include <thread>
#include <condition_variable>
#include <chrono>
#include <string>
using namespace std;

#include "../../include/tools.h"

void Work(int secs)  					/*	Thread Funktion
 * 
 * 	Dies ist die Funktion, die beim Start des Threads aufgerufen wird bzw.
 * 	dann in einem eigenen Thread laeuft. Sie hat in diesem Fall einen
 * 	Parameter, siehe auch ctor thread.
 */
{
    tools_log(); cout << "thread started, sleep for " << secs << " sec" << endl;

    // sleep for some secs
    this_thread::sleep_for(chrono::seconds(secs));
   
    tools_log(); cout << "thread done" << endl;     
}

int main()
{
    tools_log(); cout << "start threads t1 and t2" << endl;

    /*	Thread starten
     * 
     * 	Hier wird der Thread gestartet, d.h. das Thread Objekt ist an
     * 	den Thread im System gebunden und die Funktion Work laeuft.
     * 
     * 	tools_registerthreadname ist eine Hilfsfunktion aus den Tools,
     * 	so dass der jeweilige Thread nicht nur eine ID hat, sondern
     * 	einen Namen (t1 oder t2). Das erleichtert es, die Ausgabe 
     * 	zuzuordnen. Dort wird der registrierte Name ausgegeben.
     */
    thread t1(Work,2);      tools_registerthreadname(t1); 
    thread t2(Work,5);      tools_registerthreadname(t2);

    tools_log(); cout << "and wait for join" << endl;

    /*	Auf das Ende der Threads warten.
     * 
     * 	join fuehrt den Hautthread mit dem jeweiligen Thread zusammen.
     */
    t1.join();
    tools_log(); cout << "t1 joined, done" << endl;
    
    t2.join();
    tools_log(); cout << "t2 joined, done" << endl;
    
    // Einfach mal die Zeiten im ctor (2 und 5) tauschen.
         
    return EXIT_SUCCESS;
}
